from rest_framework import serializers
from .models import * 
from django.contrib.auth.models import Group , Permission
from django.contrib.auth.hashers import make_password
############## User%Module #################

class PermissionSerializer(serializers.ModelSerializer):        
    class Meta:
        model = Permission
        fields="__all__"

class ClinicGroupSerializer(serializers.ModelSerializer):
    class Meta:
        model = Group
        fields ="__all__"
        #read_only_fields = ('clinic',)

class UserMiniSerializer(serializers.ModelSerializer):
    class Meta:
        model = User
        fields=("id",'name')

class GroupWithPermissionsSerializer(serializers.ModelSerializer):        
    permissions = PermissionSerializer(many=True) 
    class Meta:
        model = Group
        fields = ['id', 'name','permissions']



#https://www.django-rest-framework.org/api-guide/serializers/#saving-instances
class UserSerializer(serializers.ModelSerializer):
    class Meta:
        model = User
        fields ="__all__"
    def create(self, validated_data):
        validated_data['password'] = make_password(validated_data.get('password'))
        return super(UserSerializer, self).create(validated_data)
    # def update(self, instance, validated_data):
    #     instance.is_password_reset = validated_data.get('is_password_reset')
    #     instance.is_active = validated_data.get('is_active')
    #     instance.password = make_password(validated_data.get('password'))
    #     return instance














# class UserSerializer(serializers.ModelSerializer):

#     def create(self, validated_data):
#         user = User(
#         username=validated_data['username'],
#         first_name=validated_data['first_name'],
#         last_name=validated_data['last_name'],
#         is_active=validated_data['is_active'],
#         created_by_id = (self.context.get("created_by")),)
#         user.set_password(validated_data['password'])
#         if (self.context.get("group_id"))== '1' : 
#             user.is_superuser = True
#             user.is_staff = True
#         else :
#             user.is_superuser = False
#             user.is_staff = False
#         user.save()
#         return user

#     class Meta:
#         model = User
#         fields = ('id','username',"first_name",'last_name','password','is_active',"created_by")   
#     def to_representation(self, instance):
#         return super(UserSerializer, self).to_representation(instance) 
class UserWithoutPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model = User
        fields="__all__"

    # def update(self, instance, validated_data):
    #     instance.username=validated_data['username']
    #     instance.last_name=validated_data['name']
    #     instance.is_active=validated_data['is_doctor']
    #     instance.created_by_id = self.context.get("created_by")
    #     if (self.context.get("group_id"))== '1' : 
    #         instance.is_superuser = True
    #         instance.is_staff = True
    #     else :
    #         instance.is_superuser = False
    #         instance.is_staff = False
    #     instance.save()
    #     return instance  

    # class Meta:
    #     model = User
    #     fields = ('id','username','name','is_doctor',"created_by")   
    # def to_representation(self, instance):
    #     return super(UserSerializer, self).to_representation(instance) 
class UserPasswordSerializer(serializers.ModelSerializer):
            
    def update(self, instance, validated_data):
        if 'password' in validated_data:
            instance.set_password(validated_data['password'])
            instance.save()
            return instance    

    class Meta:
        model = User
        fields=("password",)  
class UserSerializerMini(serializers.ModelSerializer):
    class Meta:
        model = User
        fields=("id","username","first_name",) 
class UserSerializerCust(serializers.ModelSerializer):
    #groups = GroupSerializer(many=True)
    class Meta:
        model = User
        fields ="__all__"
        # fields=('id',"last_login","is_superuser","username","first_name",
        # "last_name","email","is_staff","is_active","date_joined","created_by","groups")  
    # def to_representation(self, instance):
    #     #self.fields['group'] =  GroupSerializer(read_only=True)
    #     return super(UserSerializerCust, self).to_representation(instance)